%define anolis_release 2

Name: libiscsi
Summary: iSCSI client library
Version: 1.19.0
Release: %{anolis_release}%{?dist}
License: LGPLv2+
URL: https://github.com/sahlberg/%{name}

Source0: https://github.com/sahlberg/libiscsi/archive/%{version}/%{name}-%{version}.tar.gz

# patches from upstream to fix build
Patch1:	0001-lib-iser.c-fix-overflow_data_size-NULL-ptr-dereferen.patch
Patch2:	0002-test-tool-fix-async-read-write-test-for-bs-512.patch
Patch3:	0003-add-some-missing-includes.patch
Patch4:	0004-update-tests-.gitignore.patch
Patch5:	0005-discovery-permit-SendTargets-on-normal-sessions.patch
Patch6:	0006-test-tool-Compare-Write-skip-InvalidDataOutSize-unle.patch
Patch7:	0007-test-tool-Compare-Write-override-driver-queue_pdu-ca.patch
Patch8:	0008-test-tool-iSCSICmdSnTooLow-override-driver-queue_pdu.patch
Patch9:	0009-test-tool-iSCSICmdSnTooHigh-override-driver-queue_pd.patch
Patch10:0010-test-tool-iSCSIDataSnInvalid-override-driver-queue_p.patch
Patch11:0011-test-tool-BlockEraseReserved-skip-unless-iSCSI.patch
Patch12:0012-test-tool-BlockEraseReserved-override-driver-queue_p.patch
Patch13:0013-test-tool-CryptoEraseReserved-skip-unless-iSCSI.patch
Patch14:0014-test-tool-CryptoEraseReserved-override-driver-queue_.patch
Patch15:0015-test-tool-OverwriteReserved-skip-unless-iSCSI.patch
Patch16:0016-test-tool-OverwriteReserved-override-driver-queue_pd.patch
Patch17:0017-test-tool-remove-unused-iscsi_queue_pdu-symbol-overl.patch
Patch18:0018-build-add-convenience-library-which-exports-all-symb.patch
Patch19:0019-test-tool-build-link-against-libiscsipriv.la.patch
Patch20:0020-test-tool-replace-some-manual-PDU-tweaks-with-helper.patch
Patch21:0021-lib-use-const-for-add_data-buffers.patch
Patch22:0022-test-tool-add-iSCSI-SendTargets.Simple-test.patch
Patch23:0023-test-tool-add-iSCSI-SendTargets.Invalid-test-case.patch
Patch24:0024-test-tool-add-simple-iSCSI-NOP-Out-test.patch
Patch25:0025-test-tool-add-CHECK_FOR_ISCSI-test-filter-macro.patch
Patch26:0026-test-tool-use-CHECK_FOR_ISCSI-helper-macro.patch
Patch27:0027-test-tool-add-iSCSI-CHAP_A-negotiation-tests.patch
Patch28:0028-It-is-a-TODO-not-a-FIXME.patch
Patch29:0029-fix-LGTM.com-warning.patch
Patch30:0030-Link-with-lpthread-if-iSER-is-enabled.patch
Patch31:0031-Improve-iser_rx_desc-alignment.patch
Patch32:0032-test-tool-If-SG_IO-fails-report-why-it-failed.patch
Patch33:0033-Use-dynamic-memory-allocation-instead-of-variable-le.patch
Patch34:0034-test-tool-avoid-use-after-free-on-iscsi_logout_sync.patch
Patch35:0035-Improve-robustness-of-the-code-that-restores-.queue_.patch
Patch36:0036-iser-fix-struct-iser_rx_desc.patch
Patch37:0037-iser-remove-__packed-from-struct-iser_cm_hdr-declara.patch
Patch38:0038-iser-send-immediate-data.patch
Patch39:0039-iser-queue-pdus-when-cmdsn-exceeds-maxcmdsn.patch
Patch40:0040-Fix-data-segment-length-comparison-to-unsigned-long.patch
Patch41:0041-remove-FIXME.patch
Patch42:0042-drop-the-LD_PRELOAD-tool.patch
Patch43:0043-Simplify-logic-that-determines-when-to-send-headers.patch
Patch44:0044-test-tool-Use-extern-int-in-headers.patch
Patch45:0045-examples-iscsi-dd-print-basic-usage-information.patch
Patch46:0046-examples-iscsi-dd-measure-throughput.patch
Patch47:0047-libiscsi-Fix-a-format-specifier.patch
Patch48:0048-lib-Fix-scsi_maintenancein_datain_getfullsize.patch
Patch49:0049-test-tool-Give-up-if-READ-CAPACITY-reports-that-the-.patch

BuildRequires: make
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool
BuildRequires: popt-devel
BuildRequires: CUnit-devel
BuildRequires: libgcrypt-devel
BuildRequires: rdma-core-devel

%description
libiscsi is a library for attaching to iSCSI resources across
a network.


#######################################################################

# Conflict with iscsi-initiator-utils.

%global libiscsi_includedir %{_includedir}/iscsi
%global libiscsi_libdir %{_libdir}/iscsi

%prep
%autosetup -p1

%build
sh autogen.sh
%configure --libdir=%{libiscsi_libdir} --disable-werror
%make_build

%install
make DESTDIR=$RPM_BUILD_ROOT install pkgconfigdir=%{_libdir}/pkgconfig %{?_smp_mflags}
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
echo %{libiscsi_libdir} > $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}-%{_arch}.conf
rm $RPM_BUILD_ROOT/%{libiscsi_libdir}/libiscsi.a
rm $RPM_BUILD_ROOT/%{libiscsi_libdir}/libiscsi.la

%generate_compatibility_deps

%files
%license COPYING LICENCE-LGPL-2.1.txt
%dir %{libiscsi_libdir}
%{libiscsi_libdir}/libiscsi.so.*
%config /etc/ld.so.conf.d/*
%dir %{abidir}
%{abidir}/*.dump

%package utils
Summary: iSCSI Client Utilities
License: GPLv2+
Requires: %{name} = %{version}-%{release}

%description utils
The libiscsi-utils package provides a set of assorted utilities to connect
to iSCSI servers without having to set up the Linux iSCSI initiator.

%files utils
%license LICENCE-GPL-2.txt
%{_bindir}/iscsi-ls
%{_bindir}/iscsi-inq
%{_bindir}/iscsi-readcapacity16
%{_bindir}/iscsi-swp
%{_bindir}/iscsi-perf
%{_bindir}/iscsi-test-cu
%{_mandir}/man1/iscsi-ls.1.*
%{_mandir}/man1/iscsi-inq.1.*
%{_mandir}/man1/iscsi-swp.1.*
%{_mandir}/man1/iscsi-test-cu.1.*
%{abidir}/*-option.list

%package devel
Summary: iSCSI client development libraries
Requires: %{name} = %{version}-%{release}

%description devel
The libiscsi-devel package includes the header files for libiscsi.

%files devel
%dir %{libiscsi_includedir}
%{libiscsi_includedir}/iscsi.h
%{libiscsi_includedir}/scsi-lowlevel.h
%{libiscsi_libdir}/libiscsi.so
%{_libdir}/pkgconfig/libiscsi.pc

%package doc
Summary: Doc files for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Doc files for %{name}

%files doc
%doc README TODO

%changelog
* Thu Dec 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 1.19.0-2
- fix the source error

* Wed Mar 15 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1.19.0-1
- init from upstream
